100 DEFine PROCedure identify_drive (base,drive, ms)
110 REMark finds out drive data
120 LOCal f,s,dbase
130 :
140 dbase=base+16128+(drive-1)*16
150 ser$='' : type$='' : rev$=''
160 :
170 selectms dbase,ms
180 command dbase,236
190 s=waitdrq (dbase)
200 IF s=1 THEN
210     ddata(valid)=0
220 ELSE
230     ddata(valid)=1
240     FOR f=confw,cyls,dummy,heads,bpt,bps,sects,dummy,dummy,dummy
250         ddata(f)=PEEK_W(dbase+8)
260     END FOR f
270     FOR f=0 TO 9
280         ser$=ser$&CHR$(PEEK(dbase+8))&CHR$(PEEK(dbase+9))
290     END FOR f
300     FOR f=buftype,bufsize,eccbytes
310         ddata(f)=PEEK_W(dbase+8)
320     END FOR f
330     FOR f=0 TO 3
340         rev$=rev$&CHR$(PEEK(dbase+8))&CHR$(PEEK(dbase+9))
350     END FOR f
360     FOR f=0 TO 19
370         type$=type$&CHR$(PEEK(dbase+8))&CHR$(PEEK(dbase+9))
380     END FOR f
390     FOR f=dummy,dummy,dummy,dummy,timing,dummy,tval,tcyls,theads,tsects
400         ddata(f)=PEEK_W(dbase+8)
410     END FOR f
420     ddata(totsectors)=PEEK_L(dbase+8)
430     empty dbase
440     calculate
450 END IF
460 END DEFine
470 :
480 :
490 :
500 DEFine PROCedure selectms (dbase,ms)
510 REMark selects drives within a pair
520 :
530 POKE dbase+6,(PEEK(dbase+6)&&240)+(ms-1)*16
540 END DEFine
550 :
560 :
570 :
580 DEFine PROCedure command (dbase,comcode)
590 REMark issues command to drive
600 REMark does not check busy!
610 :
620 POKE dbase+7,comcode
630 END DEFine
640 :
650 :
660 :
670 DEFine FuNction waitdrq (dbase)
680 REMark waits for data request or timeout
690 LOCal timeout
700 :
710 timeout=300
720 FOR f=0 TO timeout
730 IF PEEK(dbase+7)=88 THEN RETurn 0
740 END FOR f
750 RETurn 1
760 END DEFine
770 :
780 :
790 :
800 DEFine PROCedure empty (dbase)
810 REMark empties rest of sector buffer
820 LOCal s
830 :
840 REPeat loop
850 IF PEEK(dbase+7)=80 THEN EXIT loop
860 s=PEEK_W(dbase+8)
870 END REPeat loop
880 END DEFine
890 :
900 :
910 :
920 DEFine PROCedure constants
930 REMark sets constants
940 :
950 drive$="0000000000000000"
960 exptype=0
970 totdrives=0
980 DIM ddata(21)
990 valid=1 : tval=5 : totsectors=9
1000 cyls=2 : heads=3 : sects=4
1010 tcyls=6 : theads=7 : tsects=8
1020 timing=10 : bufsize=11 : buftype=12
1030 eccbytes=13 : removable=14 : sectoring=15
1040 bpt=16 : bps=17 : modulation=18
1050 drate=19 : confw=20 : dummy=21
1060 base=0
1070 END DEFine
1080 :
1090 :
1100 :
1110 DEFine PROCedure calculate
1120 REMark calculates parameters from config word and truncates some values from the ddata array
1130 :
1140 IF ddata(totsectors)=0 THEN ddata(totsectors)=ddata(sects)*ddata(cyls)*ddata(heads)
1150 IF ddata(confw)>32767 THEN ddata(valid)=-1
1160 ddata(sectoring)=(ddata(confw) DIV 2)&&3
1170 ddata(modulation)=(ddata(confw) DIV 8)&&1
1180 ddata(removable)=(ddata(confw) DIV 64)&&3
1190 ddata(drate)=(ddata(confw) DIV 256)&&7
1200 ddata(timing)=ddata(timing) DIV 256
1210 END DEFine
1220 :
1230 :
1240 :
1250 DEFine PROCedure find_drives (base)
1260 REMark finds connected drives
1270 LOCal f,g,t,r,m,s,dbase,idearea
1280 idearea=base+16128
1290 :
1300 RESTORE 1300
1310 DATA 5,1,1,2,2,4,4,8,8,16,16,4,1,2,3,4,7,8,15,16,3,2,4,6,8,14,16
1320 DATA 3,1,4,5,8,13,16,2,4,8,12,16,2,3,8,11,16,2,3,8,10,16,2,1,8,9,16
1330 DATA 1,8,16,1,7,16,1,6,16,1,5,16,1,4,16,1,3,16,1,2,16,1,1,16
1340 :
1350 REMark reset all drives
1360 FOR f=0 TO 15
1370     POKE idearea+f*16,255 : POKE idearea+f*16,0
1380 END FOR f
1390 PRINT '.';
1400 tk$=inkey$(#1,100)
1410 PRINT '.';
1420 :
1430 REMark initialise readback values
1440 FOR f=15 TO 0 STEP -1
1450     POKE idearea+f*16+2,f+1
1460 END FOR f
1470 PRINT '.';
1480 :
1490 REMark test readback values to find out if drive connected
1500 FOR f=15 TO 0 STEP -1
1510     POKE idearea+f*16+6,0 : s=PEEK(idearea+f*16+2)
1520     READ t
1530     FOR g=1 TO t
1540         READ r,m
1550         IF s=r THEN drive$(r)="1" : exptype=m
1560         IF s=1 THEN EXIT f
1570     END FOR g
1580 END FOR f
1590 PRINT '.';
1600 :
1610 REMark test if slaves exist for each drive found
1620 FOR f=0 TO exptype-1
1630     dbase=idearea+f*16
1640     POKE dbase+2,1
1650     IF drive$(f+1)="1" THEN
1660         POKE dbase+6,16
1670         IF PEEK(dbase+7)=80 THEN drive$(f+1)=2
1680         POKE dbase+6,0
1690     END IF
1700     totdrives=totdrives+drive$(f+1)
1710 END FOR f
1720 PRINT '.';
1730 END DEFine
1740 :
1750 :
1760 :
1770 DEFine PROCedure find_interface
1780 REMark finds all interfaces in a system
1790 LOCal s,f
1800 :
1810 RESTORE 1810
1820 DATA 49152,65536,81920,114688,786432,802816,819200,835584,851968,868352,884736,901120,917504,933888,950272,966656,983040,999424,1.015808E6,1.032192E6
1830 :
1840 totides=0
1850 FOR f=0 TO 19
1860 PRINT '.';
1870 READ base
1880 IF PEEK_L(base)=HEX('4AFB0001') THEN
1890     IF PEEK_L(base+16124)=HEX('51494445') THEN
1900         ide(totides+1)=base
1910         totides=totides+1
1920    END IF
1930 END IF
1940 END FOR f
1950 END DEFine
1960 :
1970 :
1980 :
1990 REMark MAIN PROGRAM
2000 :
2010 totides=0 : drives=0 : failed=0
2020 DIM ide(20)
2025 OPEN#1,'con'
2030 WINDOW 512,256,0,0
2040 PAPER 0 : BORDER 1,7 : CLS
2050 BLOCK 508,10,0,0,7
2060 INK 0 : PAPER 7 : PRINT 'IDE DIAGNOSE V2.0 1994 NASTA'
2070 WINDOW 508,244,2,11
2080 PAPER 0 : INK 4 : CLS
2090 PRINT 'SEARCHING MEMORY';
2100 find_interface
2110 CLS : INK 7
2120 IF totides=0 THEN
2130     PRINT 'NO INTERFACES FOUND.' : PRINT
2140     INK 4
2150     PRINT 'You have set the base address of the interface to an unusable address,'\'you are using the inteface without a ROM or with an unrecognised ROM version,'\'or the interface is set to operate at a non-standard address.'\'The base address of the interface could not be found': PRINT : PRINT
2160     PRINT "PLEASE INPUT BASE ADDRESS OF THE INTERFACE (decimal): ";
2170     INK 7
2180     INPUT ide(1)
2190     totides=1
2200 ELSE
2210     IF totides=1 THEN
2220         PRINT '1 INTERFACE FOUND AT ADDRESS ';ide(1)
2230     ELSE
2240         PRINT totides;' INTERFACES FOUND AT ADDRESSES:'
2250         FOR f=1 TO totides
2260             PRINT ide(f);',',
2270             IF (f MOD 5)=0 THEN PRINT
2280         END FOR f
2290         INK 4
2300         PRINT \'If you have fewer interfaces then listed, check that you have connected them'\'correctly. If you find that this program finds more interfaces than there'\'are in the system, check the connector contacts and the jumperson the interface.'\'If the problem persists, you might have a non-standard system, a fault in your'\'QL, or the interface is not operating correctly.'
2310    END IF
2320 END IF
2330 INK 4
2340 PRINT \'The program will now go on to find if there are any drives connected, for'\'each of the interfaces, and perform drive diagnostics.'\\'PRESS ANY KEY TO CONTINUE'
2350 tk$=INKEY$(#1,-1)
2360 CLS
2370 FOR f=1 TO 20
2380     constants
2390     base=ide(f)
2400     IF base=0 THEN EXIT f
2410     PRINT 'SEARCHING FOR DRIVES CONNECTED TO INTERFACE ';f;
2420     find_drives base
2430     INK 7 : CLS
2440     IF totdrives=0 THEN
2450         PRINT 'NO DRIVES FOUND ON INTERFACE ';f;' AT ADDRESS';ide(f)\\
2460         INK 4
2470         PRINT 'If drives are connected to this interface, check the connections and drive power.'\'If everything checks out, either the drive or the interface might be faulty.'\\'PRESS ANY KEY TO CONTINUE'
2480     tk$=INKEY$(#1,-1)
2490     ELSE
2500         showdata base, f
2510     END IF
2520 END FOR f
2530 CLS
2540 INK 4 : PRINT 'TESTS COMPLETED.'\\'TOTAL INTERFACES: ';
2550 INK 7 : PRINT totides : INK 4 : PRINT 'TOTAL DRIVES: ';
2560 INK 7 : PRINT drives : INK 4 : PRINT 'DRIVE FAILURES: ';
2570 INK 7 : PRINT failed : INK 4 : PRINT \'PRESS ANY KEY TO EXIT'
2580 tk$=INKEY$(#1,-1)
2590 WMON
2600 :
2610 :
2620 :
2630 DEFine PROCedure showdata (base, idenum)
2640 REMark performs diagnostics and identifies every drive found
2650 :
2660 FOR g=1 TO totdrives
2670     IF drive$(g)<>0 THEN
2680         FOR s=1 TO drive$(g)
2690             CLS
2700             INK 7
2710             PRINT 'INTERFACE ';idenum;', POSITION ';g;' OF ';exptype;
2720             SELect ON s
2730             =1 : PRINT ', MASTER DRIVE: ';
2740             =2 : PRINT ', SLAVE DRIVE: ';
2750             END SELect
2760             d = diagnose(base,g,s)
2770             IF d<>1 THEN failed=failed+1
2780             drives=drives+1
2790             SELect ON d
2800                 =1 : PRINT 'PASSED DIAGNOSTICS' : iddrive base,g,s
2810                 =2 : PRINT 'REGISTER FAILURE' : INK 4 : PRINT \"The drive's internal diagnostic program has detected that a value written into"\'the control registers does not read the same.' : IF drive$(f)=2 THEN PRINT 'This drive isoperating in a master-slave arrangement. Please ensure that the'\'master-slave setup has been done properly - check positions of jumpers on the'\'drives and if needed consult the drive manufacturer. There is also the'\'possibility that this drive combination is incompatible if drives are of'\'older type.'
2820                 =3 : PRINT 'BUFFER ERROR' : INK 4 : PRINT \'The sector buffer RAM test has failed, indicating the RAM has unusable bits.'\'The drive is most probably faulty.'
2830                 =4 : PRINT 'ECC LOGIC FAILED' : INK 4 : PRINT \'The ECC logic self test has determined that the ECC logic is not responding'\'correctly. The ECC logic is faulty, but the drive may operate with the ECC'\'logic disabled.Consult the manufacturer to find out if an ECC failure'\'disables ECC automatically. It is advisable to change the drive for a'\'fully functional one!'
2840                 =5 : PRINT 'DRIVE CONTROLLER BAD' : INK 4 : PRINT \'The internal CPU, controller, ROM checksum or RAM test has failed. The drive'\'is almost certainly faulty.'
2850             END SELect
2860             INK 4
2870             PRINT \'PRESS ANY KEY TO CONTINUE'
2880             tk$=INKEY$(#1,-1)
2890         END FOR s
2900     END IF
2910 END FOR g
2920 END DEFine
2930 :
2940 :
2950 :
2960 DEFine FuNction diagnose(base,pos,ms)
2970 REMark invokes IDE diagnose command
2980 LOCal dbase,l
2990 :
3000 dbase=base+16128+(pos-1)*16
3010 selectms dbase,ms
3020 command dbase,HEX('90')
3030 REPeat l:IF PEEK(dbase+7)=80 THEN EXIT l:END REPeat l
3040 RETurn PEEK(dbase+1)
3050 END DEFine
3060 :
3070 :
3080 :
3090 DEFine PROCedure iddrive(base,pos,ms)
3100 REMark front end for identify_drive procedure, with display code
3110 LOCal f,x,y,t$,p$,s
3120 :
3130 RESTORE 3130
3140 DATA 2,0,'DRIVE TYPE:',3,0,'REVISION:',4,0,'SERIAL NUMBER:'
3150 DATA 6,0,'DRIVE GEOMETRY:',7,0,'TRANSLATE GEOMETRY:'
3160 DATA 6,20,'Tracks:',7,20,'Tracks:'
3170 DATA 6,35,'Sectors:',7,35,'Sectors:'
3180 DATA 6,48,'Heads:',7,48,'Heads:'
3190 DATA 9,0,'FORMATTED CAPACITY,',9,20,'Sectors:',10,20,'Mbytes:'
3200 DATA 12,0,'MEDIUM TYPE:',12,32,'BUFFER MEMORY SIZE:'
3210 DATA 13,0,'RECORDING METHOD:',13,32,'BUFFER MEMORY TYPE:'
3220 DATA 14,0,'SECTORING METHOD:'
3230 DATA 15,0,'DATA RATE GROUP:',15,32,'ECC DATA LENGTH:'
3240 DATA 17,0,'RECORDING DENSITY, Bytes per track:'
3250 DATA 18,19,'Bytes per sector:'
3260 DATA 20,0,'SHORTEST BUS ACCESS CYCLE DURATION:'
3270 :
3280 identify_drive base,pos,ms
3290 IF ddata(valid)=1 THEN
3300     INK 4
3310     FOR f=0 TO 23
3320         READ y,x,t$
3330         AT y,x : PRINT t$
3340     END FOR f
3350     INK 7
3360     AT 2,16 : PRINT type$
3370     AT 3,16 : PRINT rev$
3380     AT 4,16 : PRINT ser$
3390     RESTORE 3490
3400     FOR f=cyls,sects,heads,eccbytes,bpt,bps,totsectors
3410         READ y,x,t$
3420         AT y,x : PRINT ddata(f);t$
3430     END FOR f
3440     FOR f=tcyls,tsects,theads
3450         READ y,x
3460         AT y,x
3470         IF ddata(tval)=1 THEN
3480             PRINT ddata(f)
3490         ELSE
3500             PRINT '-'
3510         END IF
3520     END FOR f
3530     READ y,x
3540     AT y,x : PRINT ddata(bufsize)/2;' kbytes'
3550     READ y,x
3560     AT y,x : PRINT ddata(totsectors)/2048
3570     s=ddata(buftype)
3580     SELect ON s
3590     =0: t$='unspecified' : p$=''
3600     =1: t$='single ported' : p$=''
3610     =2: t$='dual ported, multisector' : p$=''
3620     =3: t$='dual ported, multisector' : p$='with read caching'
3630     =REMAINDER : t$='unknown' : p$=''
3640     END SELect
3650     READ y,x : AT y,x : PRINT t$
3660     READ y,x : AT y,x : PRINT p$
3670     s=ddata(removable)
3680     READ y,x : AT y,x
3690     SELect ON s
3700     =1 : PRINT 'fixed'
3710     =2 : PRINT 'removable'
3720     =REMAINDER : PRINT 'unknown'
3730     END SELect
3740     READ y,x : AT y,x
3750     IF ddata(modulation)=0 THEN
3760         PRINT 'MFM'
3770     ELSE
3780         PRINT 'RLL'
3790     END IF
3800     READ y,x : AT y,x
3810     s=ddata(sectoring)
3820     SELect ON s
3830     =0 : PRINT 'unspecified'
3840     =1 : PRINT 'hard'
3850     =2 : PRINT 'soft'
3860     =3 : PRINT 'hard / soft'
3870     END SELect
3880     READ y,x : AT y,x
3890     s=ddata(drate)
3900     SELect ON s
3910     =1 : PRINT '<5 Mbit/s'
3920     =2 : PRINT '5..10 Mbit/s'
3930     =4 : PRINT '>10 Mbit/s'
3940     =REMAINDER : PRINT 'unknown'
3950     END SELect
3960     READ y,x : AT y,x
3970     s=ddata(timing)
3980     SELect ON s
3990     =0 : PRINT '600 ns'
4000     =1 : PRINT '383 ns'
4010     =2 : PRINT '240 ns'
4020     =REMAINDER : PRINT '<240 ns'
4030     END SELect
4040 ELSE
4050     INK 7
4060     IF ddata(valid)=0 THEN
4070         PRINT 'THIS DRIVE DOES NOT SUPPORT THE ID COMMAND'
4080         INK 4
4090         PRINT \'This is an old, or pre-standard drive. Please consult manufacturer for the'\'correct drive geometry data.'
4100     ELSE
4110         PRINT 'THIS IS AN IDE CD ROM DRIVE, OR OTHER EIDE DRIVE'
4120         INK 4
4130         PRINT \'This version of the program cannot identify EIDE drives. Please contact the'\'author for a new version of this utility at the following address:'\\'Zeljko Nastasic'\'Augusta Senoe 2, 41211 Zapresic'\'CROATIA'
4140     END IF
4150 END IF
4160 INK 4
4170 :
4180 DATA 6,28,'',6,44,'',6,55,'',15,52,' bytes',17,37,'',18,37,'',9,29,''
4190 DATA 7,28,7,44,7,55,12,52,10,29,13,52,14,52,12,18,13,18,14,18,15,18,20,36
4200 :
4210 END DEFine
